#ifndef _FSAYS_ARCADE_CONTROLLER_H
#define _FSAYS_ARCADE_CONTROLLER_H

#include <fsaysarcadekeyset.h>
#include <linux/input.h>

#define LOCAL_ESCAPE 27
#define MY_SEC          1000000
#define MY_TSEC          100000
#define MY_FHSEC          50000
#define MY_HSEC           10000
#define MY_FMSEC           5000  
#define MY_MSEC            1000  
#define MY_USEC               1  

const int NumberOfArcadeKeySets = 8;
class FSaysArcadeController
{
    public:
        // constructors
        FSaysArcadeController();
        ~FSaysArcadeController();

		int run();

    private:
		void startKey(FSaysRemoteKey* remoteKey);
		void endKey(FSaysRemoteKey* remoteKey);
		void processPortA(int port, int value);
		void processPortB(int port, int value);
		void processPortC(int port, int value);
		void processPortD(int port, int value);
		void processPortE(int port, int value);

		void halt();
		void reboot();

		FSaysArcadeKeySet* _arcadeKeySets[NumberOfArcadeKeySets];
		FSaysArcadeKeySet* _p_currentArcadeKeySet;
		
		struct input_event _event; 
		struct input_event _event_end;
		int _fd;
		int _haltCounter;
		int _rebootCounter;
		bool _doHalt;
		bool _doReboot;
		bool _keepRunning;

		int _portA;
		int _portB;
		int _portC;
		int _portD;
		int _portE;
};
#endif
