#include <linux/input.h>
#include <errno.h>
#include <printf.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <linux/i2c-dev.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/input.h>
#include <fsaysarcadecontroller.h>

FSaysArcadeController::FSaysArcadeController()
{
		int keySetIndex = 0;

		_arcadeKeySets[keySetIndex] = new FSaysArcadeKeySet();
		// key set 0 (default)
		FSaysArcadeKeySet* pArcadeKeySet = new FSaysArcadeKeySet();
		_arcadeKeySets[keySetIndex++] = pArcadeKeySet;

		pArcadeKeySet->setRemoteKeyForPlayerOneGreenTopButton(new FSaysRemoteKey(KEY_Y, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneGreenBottomButton(new FSaysRemoteKey(KEY_F12, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneBlueTopButton(new FSaysRemoteKey(KEY_H, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneBlueBottomButton(new FSaysRemoteKey(KEY_BACKSPACE, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneYellowTopButton(new FSaysRemoteKey(KEY_T, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneYellowBottomButton(new FSaysRemoteKey(KEY_SPACE, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneRedTopButton(new FSaysRemoteKey(KEY_N, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneRedBottomButton(new FSaysRemoteKey(KEY_COMMA, false));

        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickWest(new FSaysRemoteKey(KEY_F2, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickNorth(new FSaysRemoteKey(KEY_F4, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickEast(new FSaysRemoteKey(KEY_F6, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickSouth(new FSaysRemoteKey(KEY_F8, false));

        pArcadeKeySet->setRemoteKeyForOnePlayerButton(new FSaysRemoteKey(KEY_F1, false));
        pArcadeKeySet->setRemoteKeyForTwoPlayersButton(new FSaysRemoteKey(KEY_F3, false));

        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickWest(new FSaysRemoteKey(KEY_LEFT, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickNorth(new FSaysRemoteKey(KEY_UP, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickEast(new FSaysRemoteKey(KEY_RIGHT, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickSouth(new FSaysRemoteKey(KEY_DOWN, false));

        pArcadeKeySet->setRemoteKeyForPlayerTwoRedTopButton(new FSaysRemoteKey(KEY_ENTER, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoRedBottomButton(new FSaysRemoteKey(KEY_DOT, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoYellowTopButton(new FSaysRemoteKey(KEY_1, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoYellowBottomButton(new FSaysRemoteKey(KEY_2, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoBlueTopButton(new FSaysRemoteKey(KEY_F5, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoBlueBottomButton(new FSaysRemoteKey(KEY_F7, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoGreenTopButton(new FSaysRemoteKey(KEY_J, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoGreenBottomButton(new FSaysRemoteKey(KEY_X, false));


		// key set 1 (a-z)
		pArcadeKeySet = new FSaysArcadeKeySet();
		_arcadeKeySets[keySetIndex++] = pArcadeKeySet;
		pArcadeKeySet->setRemoteKeyForPlayerOneGreenTopButton(new FSaysRemoteKey(KEY_A, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneGreenBottomButton(new FSaysRemoteKey(KEY_E, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneBlueTopButton(new FSaysRemoteKey(KEY_B, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneBlueBottomButton(new FSaysRemoteKey(KEY_F, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneYellowTopButton(new FSaysRemoteKey(KEY_C, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneYellowBottomButton(new FSaysRemoteKey(KEY_G, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneRedTopButton(new FSaysRemoteKey(KEY_D, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneRedBottomButton(new FSaysRemoteKey(KEY_H, false));

        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickWest(new FSaysRemoteKey(KEY_I, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickNorth(new FSaysRemoteKey(KEY_J, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickEast(new FSaysRemoteKey(KEY_K, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickSouth(new FSaysRemoteKey(KEY_L, false));

        pArcadeKeySet->setRemoteKeyForOnePlayerButton(new FSaysRemoteKey(KEY_M, false));
        pArcadeKeySet->setRemoteKeyForTwoPlayersButton(new FSaysRemoteKey(KEY_N, false));

        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickWest(new FSaysRemoteKey(KEY_O, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickNorth(new FSaysRemoteKey(KEY_P, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickEast(new FSaysRemoteKey(KEY_Q, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickSouth(new FSaysRemoteKey(KEY_R, false));

        pArcadeKeySet->setRemoteKeyForPlayerTwoRedTopButton(new FSaysRemoteKey(KEY_S, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoRedBottomButton(new FSaysRemoteKey(KEY_W, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoYellowTopButton(new FSaysRemoteKey(KEY_T, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoYellowBottomButton(new FSaysRemoteKey(KEY_X, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoBlueTopButton(new FSaysRemoteKey(KEY_U, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoBlueBottomButton(new FSaysRemoteKey(KEY_Y, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoGreenTopButton(new FSaysRemoteKey(KEY_V, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoGreenBottomButton(new FSaysRemoteKey(KEY_Z, false));


		// key set 2 (A-Z)
		pArcadeKeySet = new FSaysArcadeKeySet();
		_arcadeKeySets[keySetIndex++] = pArcadeKeySet;
		pArcadeKeySet->setRemoteKeyForPlayerOneGreenTopButton(new FSaysRemoteKey(KEY_A, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneGreenBottomButton(new FSaysRemoteKey(KEY_E, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneBlueTopButton(new FSaysRemoteKey(KEY_B, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneBlueBottomButton(new FSaysRemoteKey(KEY_F, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneYellowTopButton(new FSaysRemoteKey(KEY_C, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneYellowBottomButton(new FSaysRemoteKey(KEY_G, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneRedTopButton(new FSaysRemoteKey(KEY_D, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneRedBottomButton(new FSaysRemoteKey(KEY_H, true));

        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickWest(new FSaysRemoteKey(KEY_I, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickNorth(new FSaysRemoteKey(KEY_J, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickEast(new FSaysRemoteKey(KEY_K, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickSouth(new FSaysRemoteKey(KEY_L, true));

        pArcadeKeySet->setRemoteKeyForOnePlayerButton(new FSaysRemoteKey(KEY_M, true));
        pArcadeKeySet->setRemoteKeyForTwoPlayersButton(new FSaysRemoteKey(KEY_N, true));

        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickWest(new FSaysRemoteKey(KEY_O, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickNorth(new FSaysRemoteKey(KEY_P, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickEast(new FSaysRemoteKey(KEY_Q, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickSouth(new FSaysRemoteKey(KEY_R, true));

        pArcadeKeySet->setRemoteKeyForPlayerTwoRedTopButton(new FSaysRemoteKey(KEY_S, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoRedBottomButton(new FSaysRemoteKey(KEY_W, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoYellowTopButton(new FSaysRemoteKey(KEY_T, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoYellowBottomButton(new FSaysRemoteKey(KEY_X, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoBlueTopButton(new FSaysRemoteKey(KEY_U, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoBlueBottomButton(new FSaysRemoteKey(KEY_Y, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoGreenTopButton(new FSaysRemoteKey(KEY_V, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoGreenBottomButton(new FSaysRemoteKey(KEY_Z, true));

		// key set 3 ()
		pArcadeKeySet = new FSaysArcadeKeySet();
		_arcadeKeySets[keySetIndex++] = pArcadeKeySet;
		pArcadeKeySet->setRemoteKeyForPlayerOneGreenTopButton(new FSaysRemoteKey(KEY_R, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneGreenBottomButton(new FSaysRemoteKey(KEY_B, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneBlueTopButton(new FSaysRemoteKey(KEY_C, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneBlueBottomButton(new FSaysRemoteKey(KEY_D, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneYellowTopButton(new FSaysRemoteKey(KEY_E, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneYellowBottomButton(new FSaysRemoteKey(KEY_E, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneRedTopButton(new FSaysRemoteKey(KEY_F, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneRedBottomButton(new FSaysRemoteKey(KEY_G, true));

        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickWest(new FSaysRemoteKey(KEY_H, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickNorth(new FSaysRemoteKey(KEY_I, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickEast(new FSaysRemoteKey(KEY_J, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickSouth(new FSaysRemoteKey(KEY_K, true));

        pArcadeKeySet->setRemoteKeyForOnePlayerButton(new FSaysRemoteKey(KEY_L, true));
        pArcadeKeySet->setRemoteKeyForTwoPlayersButton(new FSaysRemoteKey(KEY_M, true));

        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickWest(new FSaysRemoteKey(KEY_O, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickNorth(new FSaysRemoteKey(KEY_P, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickEast(new FSaysRemoteKey(KEY_Q, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickSouth(new FSaysRemoteKey(KEY_R, true));

        pArcadeKeySet->setRemoteKeyForPlayerTwoRedTopButton(new FSaysRemoteKey(KEY_S, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoRedBottomButton(new FSaysRemoteKey(KEY_T, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoYellowTopButton(new FSaysRemoteKey(KEY_U, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoYellowBottomButton(new FSaysRemoteKey(KEY_V, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoBlueTopButton(new FSaysRemoteKey(KEY_W, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoBlueBottomButton(new FSaysRemoteKey(KEY_X, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoGreenTopButton(new FSaysRemoteKey(KEY_Y, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoGreenBottomButton(new FSaysRemoteKey(KEY_Z, true));

		// key set 4 (0-9 + shift 0-9)
		pArcadeKeySet = new FSaysArcadeKeySet();
		_arcadeKeySets[keySetIndex++] = pArcadeKeySet;
		pArcadeKeySet->setRemoteKeyForPlayerOneGreenTopButton(new FSaysRemoteKey(KEY_1, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneGreenBottomButton(new FSaysRemoteKey(KEY_1, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneBlueTopButton(new FSaysRemoteKey(KEY_2, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneBlueBottomButton(new FSaysRemoteKey(KEY_2, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneYellowTopButton(new FSaysRemoteKey(KEY_3, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneYellowBottomButton(new FSaysRemoteKey(KEY_3, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneRedTopButton(new FSaysRemoteKey(KEY_4, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneRedBottomButton(new FSaysRemoteKey(KEY_4, false));

        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickWest(new FSaysRemoteKey(KEY_5, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickNorth(new FSaysRemoteKey(KEY_5, true));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickEast(new FSaysRemoteKey(KEY_6, false));
        pArcadeKeySet->setRemoteKeyForPlayerOneJoyStickSouth(new FSaysRemoteKey(KEY_6, true));

        pArcadeKeySet->setRemoteKeyForOnePlayerButton(new FSaysRemoteKey(KEY_7, false));
        pArcadeKeySet->setRemoteKeyForTwoPlayersButton(new FSaysRemoteKey(KEY_7, true));

        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickWest(new FSaysRemoteKey(KEY_8, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickNorth(new FSaysRemoteKey(KEY_8, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickEast(new FSaysRemoteKey(KEY_9, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoJoyStickSouth(new FSaysRemoteKey(KEY_9, true));

        pArcadeKeySet->setRemoteKeyForPlayerTwoRedTopButton(new FSaysRemoteKey(KEY_0, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoRedBottomButton(new FSaysRemoteKey(KEY_0, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoYellowTopButton(new FSaysRemoteKey(KEY_MINUS, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoYellowBottomButton(new FSaysRemoteKey(KEY_MINUS, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoBlueTopButton(new FSaysRemoteKey(KEY_EQUAL, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoBlueBottomButton(new FSaysRemoteKey(KEY_EQUAL, false));
        pArcadeKeySet->setRemoteKeyForPlayerTwoGreenTopButton(new FSaysRemoteKey(KEY_SLASH, true));
        pArcadeKeySet->setRemoteKeyForPlayerTwoGreenBottomButton(new FSaysRemoteKey(KEY_SLASH, false));

		_p_currentArcadeKeySet = _arcadeKeySets[0];
}

FSaysArcadeController::~FSaysArcadeController()
{
	printf("destroying FSaysArcadeController: %x\n", this);
	for(int i=0; i< NumberOfArcadeKeySets;i++)
	{
		FSaysArcadeKeySet* pArcadeKeySet = _arcadeKeySets[i];
		if(pArcadeKeySet)
		{
			delete pArcadeKeySet;
		}
	}
}

int FSaysArcadeController::run()
{
    int file;
    char filename[40];
    const char *buffer;
    int addr = 0x21;
    int result = 0;

    sprintf(filename,"/dev/i2c-1");
    if ((file = open(filename,O_RDWR)) < 0) {
        printf("Failed to open the bus.");
        /* ERROR HANDLING; you can check errno to see what went wrong */
        exit(1);
    }

    if (ioctl(file,I2C_SLAVE, addr) < 0) {
        printf("Failed to acquire bus access and/or talk to slave.\n");
        /* ERROR HANDLING; you can check errno to see what went wrong */
        exit(1);
    }

    char buf[10] = {0};
    float data;
    char channel;

    _fd = open("/dev/input/event0", O_RDWR);
    
    if(_fd){
        memset(&_event, 0, sizeof(_event));
        memset(&_event_end, 0, sizeof(_event_end));
    }
    else
    {
        printf("Errro open keyboard:%s\n", strerror(errno));
        exit(1);
    }

    int bufA=0;
    int bufB=0;
    int bufC=0;
    int bufD=0;
    int bufE=0;
	_keepRunning = true;
    while(_keepRunning)
    {
        buf[0] = 0xF6; // command for slave: collect data

        if (write(file,buf,1) != 1) {
            /* ERROR HANDLING: i2c transaction failed */
            printf("Failed to write to the i2c bus.\n");
            buffer = strerror(errno);
            printf(buffer);
            printf("\n\n");
        }

        if(_doHalt)
        {
            _haltCounter++;
            if(_haltCounter > 500)
            {
                halt();
            }
        }

        if(_doReboot)
        {
            _rebootCounter++;
            if(_rebootCounter > 500)
            {
                reboot();
            }
        }
    
        int calculatedChecksum = 0;
        int checksum = 0;
        for(int i = 0; i<5; i++) {
            // Using I2C Read
            if (read(file,buf,1) != 1) {
                /* ERROR HANDLING: i2c transaction failed */
                printf("Failed to read from the i2c bus.\n");
                buffer = strerror(errno);
                printf(buffer);
                printf("\n\n");
            } else {
                //printf("%B\n", buf[0]);
                int x = buf[0];
                switch(i)
                {
                    case 0:
                        bufA = buf[0];
                        /*if(_portA != buf[0])
                        {
                            printf("PORT A changed to: ");
                            // unavailable
                            if(x & 128)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // unavailable
                            if(x & 64)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: green top
                            if(x & 32)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: green bottom
                            if(x & 16)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: blue top 
                            if(x & 8)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: blue bottom 
                            if(x & 4)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: yellow top 
                            if(x & 2)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: yellow bottom 
                            if(x & 1)
                            {
                                printf("1b\n");
                            }
                            else
                            {
                                printf("0b\n");
                            }
                        }
						*/
                        break;
                    case 1:
                        bufB = buf[0];
                        /*if(_portB != buf[0])
                        {
                            printf("PORT B changed to: ");
                            // p2: red top
                            if(x & 128)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: red bottom
                            if(x & 64)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: east
                            if(x & 32)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: west
                            if(x & 16)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: south
                            if(x & 8)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: north
                            if(x & 4)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // unavailable
                            if(x & 2)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // unavailable
                            if(x & 1)
                            {
                                printf("1b\n");
                            }
                            else
                            {
                                printf("0b\n");
                            }
                        }
						*/
                        break;
                    case 2:
                        bufC = buf[0];
                        /*
						if(_portC != buf[0])
                        {
                            printf("PORT C changed to: ");
                            // p1: green top 
                            if(x & 128)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: green bottom 
                            if(x & 64)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: blue top 
                            if(x & 32)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: blue bottom 
                            if(x & 16)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // unavailable
                            if(x & 8)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // green side button 
                            if(x & 4)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // two players button
                            if(x & 2)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // one player button
                            if(x & 1)
                            {
                                printf("1b\n");
                            }
                            else
                            {
                                printf("0b\n");
                            }
                        }
						*/
                        break;
                    case 3:
                        bufD = buf[0];
                        /*if(_portD != buf[0])
                        {
                            printf("PORT D changed to: ");
                            // blue side button
                            if(x & 128)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // red side button
                            if(x & 64)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // yellow side button
                            if(x & 32)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // white side button
                            if(x & 16)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: yellow top
                            if(x & 8)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: yellow bottom
                            if(x & 4)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: red top
                            if(x & 2)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p1: red bottom
                            if(x & 1)
                            {
                                printf("1b\n");
                            }
                            else
                            {
                                printf("0b\n");
                            }
                        }
						*/
                        break;
                    case 4:
                        bufE = buf[0];
                        /*if(_portE != buf[0])
                        {
                            printf("PORT E changed to: ");
                            // unavailable
                            if(x & 128)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // unavailable
                            if(x & 64)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // unavailable
                            if(x & 32)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // unavailable
                            if(x & 16)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: east
                            if(x & 8)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: west
                            if(x & 4)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: south
                            if(x & 2)
                            {
                                printf("1");
                            }
                            else
                            {
                                printf("0");
                            }
                            // p2: north
                            if(x & 1)
                            {
                                printf("1b\n");
                            }
                            else
                            {
                                printf("0b\n");
                            }
                        }
						*/
                        break;
                }
                calculatedChecksum += buf[0];
            }


            int keySetIndex = 0;
            // port c, bit 4, green side button => bit 0 of key set selector
            if(!(bufC & 4))
            {
                keySetIndex += 1;
            }

            // port d, bit 4: white side button => bit 2 of key set selector
            if(!(bufD & 16))
            {
                keySetIndex += 2;
            }

            // port d, bit 5: yellow side button => bit 2 of key set selector
            if(!(bufD & 32))
            {
                keySetIndex += 4;
            }

			_p_currentArcadeKeySet = _arcadeKeySets[keySetIndex];
            processPortA(_portA, bufA);
            processPortB(_portB, bufB);
            processPortC(_portC, bufC);
            processPortD(_portD, bufD);
            processPortE(_portE, bufE);

            _portA = bufA;
            _portB = bufB;
            _portC = bufC;
            _portD = bufD;
            _portE = bufE;
        }
        if (read(file,buf,1) == 1) 
        {
            checksum = buf[0]*256;
        }
        if (read(file,buf,1) == 1) 
        {
            checksum += buf[0];
        }
        if(calculatedChecksum !=  checksum)
        {
            printf("%d == %d ? %s\n", calculatedChecksum , checksum, calculatedChecksum == checksum ? "ja" : "nee");
        }
        

        usleep(MY_FMSEC);

    }

    return 0;
}




void FSaysArcadeController::startKey(FSaysRemoteKey* remoteKey)
{
    //printf("--> Startkey %d, %d\n", key, shiftKey);
    if(remoteKey->getShiftKey())
    {
        gettimeofday(&_event.time, NULL);
        _event.type = EV_KEY;
        _event.code = KEY_LEFTSHIFT;
        _event.value = 1;
        write(_fd, &_event, sizeof(_event));
    }
    gettimeofday(&_event.time, NULL);
    _event.type = EV_KEY;
    _event.code = remoteKey->getKey();
    _event.value = 1;
    usleep(MY_HSEC);
    gettimeofday(&_event_end.time, NULL);
    _event_end.type = EV_SYN;
    _event_end.code = SYN_REPORT;
    _event_end.value = 1;
    write(_fd, &_event, sizeof(_event));
    write(_fd, &_event_end, sizeof(_event_end));
    usleep(MY_FHSEC);
}

void FSaysArcadeController::endKey(FSaysRemoteKey* remoteKey)
{
    //printf("--> Endkey %d, %d\n", key, shiftKey);
    gettimeofday(&_event.time, NULL);
    _event.type = EV_KEY;
    _event.code = remoteKey->getKey();
    _event.value = 0;
    usleep(MY_HSEC);
    write(_fd, &_event, sizeof(_event));
    if(remoteKey->getShiftKey())
    {
        gettimeofday(&_event.time, NULL);
        _event.type = EV_KEY;
        _event.code = KEY_LEFTSHIFT;
        _event.value = 0;
        write(_fd, &_event, sizeof(_event));
    }
    gettimeofday(&_event_end.time, NULL);
    _event_end.type = EV_SYN;
    _event_end.code = SYN_REPORT;
    _event_end.value = 0;
    write(_fd, &_event, sizeof(_event));
    write(_fd, &_event_end, sizeof(_event_end));
    usleep(MY_FHSEC);
}

void FSaysArcadeController::processPortA(int port, int value)
{
    if(port != value && _p_currentArcadeKeySet)
    {
        // bit 7: unavailable
        // bit 6: unavailable
        // bit 5: p2, green top
        if((port ^ value) & 32)
        {
            if(value & 32) 
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoGreenTopButton());
            }
            else
            {   
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoGreenTopButton());
            }
        }

        // bit 4: p2, green bottom
        if((port ^ value) & 16)
        {
            if(value & 16)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoGreenBottomButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoGreenBottomButton());
            }
        }

        // bit 3, blue top 
        if((port ^ value) & 8)
        {
            if(value & 8)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoBlueTopButton());
            }
            else 
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoBlueTopButton());
            }
        }
        
        // bit 2: p2, blue bottom 
        if((port ^ value) & 4)
        {
            if(value & 4) 
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoBlueBottomButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoBlueBottomButton());
            }
        }

        // bit 1: p2, yellow top 
        if((port ^ value) & 2)
        {
            if(value & 2)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoYellowTopButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoYellowTopButton());
            }
        }

        // bit 0: p2, yellow bottom 
        if((port ^ value) & 1)
        {
            if(value & 1)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoYellowBottomButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoYellowBottomButton());
            }
        }
    }
}

void FSaysArcadeController::processPortB(int port, int value)
{
    if(port != value && _p_currentArcadeKeySet)
    {
        // bit 7: p2, red top
        if((port ^ value) & 128)
        {
            if(value & 128)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoRedTopButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoRedTopButton());
            }
        }
        
        // bit 6: p2, red bottom
        if((port ^ value) & 64)
        {
            if(value & 64)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoRedBottomButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoRedBottomButton());
            }
        }

        // bit 5: p1, east 
        if((port ^ value) & 32)
        {
            if(value & 32)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneJoyStickEast());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneJoyStickEast());
            }
        }

        // bit 4: p1, west
        if((port ^ value) & 16)
        {
            if(value & 16)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneJoyStickWest());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneJoyStickWest());
            }
        }
        // bit 3: p1, south
        if((port ^ value) & 8)
        {
            if(value & 8) 
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneJoyStickSouth());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneJoyStickSouth());
            }
        }
        // bit 2: p1, north
        if((port ^ value) & 4)
        {
            if(value & 4)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneJoyStickNorth());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneJoyStickNorth());
            }
        }

        // bit 1: unavailable
        // bit 0: unavailable
    }
}

void FSaysArcadeController::processPortC(int port, int value)
{
    if(port != value && _p_currentArcadeKeySet)
    {
        // bit 7: p1, green top 
        if((port ^ value) & 128)
        {
            if(value & 128)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneGreenTopButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneGreenTopButton());
            }
        }

        // bit 6: p1, green bottom 
        if((port ^ value) & 64)
        {
            if(value & 64)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneGreenBottomButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneGreenBottomButton());
            }
        }

        // bit 5: p1, blue top 
        if((port ^ value) & 32)
        {
            if(value & 32)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneBlueTopButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneBlueTopButton());
            }
        }

        // bit 4: p1, blue bottom 
        if((port ^ value) & 16)
        {
            if(value & 16)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneBlueBottomButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneBlueBottomButton());
            }
        }

        // bit 3: unavailable
        // bit 2: green side button 
        // bit 1: two players button
        if((port ^ value) & 2)
        {
            if(value & 2)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForTwoPlayersButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForTwoPlayersButton());
            }
        }

        // bit 0: one player button
        if((port ^ value) & 1)
        {
            if(value & 1)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForOnePlayerButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForOnePlayerButton());
            }
        }
    }
}

void FSaysArcadeController::halt()
{
	_keepRunning = false;
    printf("halting system...\n");
    setreuid(geteuid(), getuid());
    system("sudo /sbin/halt");
    setreuid(geteuid(), getuid());
}

void FSaysArcadeController::reboot()
{
	_keepRunning = false;
    printf("rebooting system...\n");
    setreuid(geteuid(), getuid());
    system("sudo /sbin/reboot");
    setreuid(geteuid(), getuid());
}

void FSaysArcadeController::processPortD(int port, int value)
{
    if(port != value && _p_currentArcadeKeySet)
    {
        // bit 7: blue side button
        if((port ^ value) & 128)
        {
            if(value & 128)
            {
                _doHalt = 0;
                printf("Cancelling halt: %d\n", _haltCounter);
                _haltCounter = 0;
            }
            else
            {
                _doHalt = 1;
            }
        }
        // bit 6: red side button
        if((port ^ value) & 64)
        {
            if(value & 64)
            {
                _doReboot = 0;
                printf("Cancelling reboot: %d\n", _rebootCounter);
                _rebootCounter = 0;
            }
            else
            {
                _doReboot = 1;
            }
        }
        // bit 5: yellow side button
        // bit 4: white side button
        // bit 3: p1, yellow top
        if((port ^ value) & 8)
        {
            if(value & 8)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneYellowTopButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneYellowTopButton());
            }
        }
        // bit 2: p1, yellow bottom
        if((port ^ value) & 4)
        {
            if(value & 4)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneYellowBottomButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneYellowBottomButton());
            }
        }
        // bit 1: p1, red top
        if((port ^ value) & 2)
        {
            if(value & 2)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneRedTopButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneRedTopButton());
            }
        }
        // bit 0: p1, red bottom
        if((port ^ value) & 1)
        {
            if(value & 1)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneRedBottomButton());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerOneRedBottomButton());
            }
        }
    }
}

void FSaysArcadeController::processPortE(int port, int value)
{
    if(port != value && _p_currentArcadeKeySet)
    {
        // bit 3: p2, east
        if((port ^ value) & 8)
        {
            if(value & 8)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoJoyStickEast());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoJoyStickEast());
            }
        }

        // bit 2: p2, west
        if((port ^ value) & 4)
        {
            if(value & 4)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoJoyStickWest());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoJoyStickWest());
            }
        }

        // bit 1: p1, south
        if((port ^ value) & 2)
        {
            if(value & 2)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoJoyStickSouth());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoJoyStickSouth());
            }
        }

        // bit 1: p1, north
        if((port ^ value) & 1)
        {
            if(value & 1)
            {
                endKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoJoyStickNorth());
            }
            else
            {
                startKey(_p_currentArcadeKeySet->getRemoteKeyForPlayerTwoJoyStickNorth());
            }
        }
    }
}













