#include <termios.h>
#include <stdio.h>
#include <signal.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <linux/input.h>
#include "fsaysinput.h"

FSaysInput::FSaysInput(){
    fd = open("/dev/input/event0", O_RDWR | O_CREAT);
    if(fd){
        memset(&event, 0, sizeof(event));
        memset(&event, 0, sizeof(event_end));
        status = 0;
    }
    else
    {
        printf("Errro open input:%s\n", strerror(errno));
        status = -1;
    }
}

int FSaysInput::getStatus(void)
{
    return status;
}

void FSaysInput::startKey(int key)
{
    if(shiftKey)
    {
        gettimeofday(&event.time, NULL);
        event.type = EV_KEY;
        event.code = KEY_LEFTSHIFT;
        event.value = 1;
        write(fd, &event, sizeof(event));
    }
    gettimeofday(&event.time, NULL);
    event.type = EV_KEY;
    event.code = key;
    event.value = 1;
    usleep(MY_HSEC);
    gettimeofday(&event_end.time, NULL);
    event_end.type = EV_SYN;
    event_end.code = SYN_REPORT;
    event_end.value = 1;
    write(fd, &event, sizeof(event));
    write(fd, &event_end, sizeof(event_end));
    usleep(MY_FHSEC);
}

void FSaysInput::endKey(int key)
{
    gettimeofday(&event.time, NULL);
    event.type = EV_KEY;
    event.code = key;
    event.value = 0;
    usleep(MY_HSEC);
    write(fd, &event, sizeof(event));
    if(shiftKey)
    {
        gettimeofday(&event.time, NULL);
        event.type = EV_KEY;
        event.code = KEY_LEFTSHIFT;
        event.value = 0;
        shiftKey = false;
    }
    gettimeofday(&event_end.time, NULL);
    event_end.type = EV_SYN;
    event_end.code = SYN_REPORT;
    event_end.value = 0;
    write(fd, &event, sizeof(event));
    write(fd, &event_end, sizeof(event_end));
    usleep(MY_FHSEC);
}

void FSaysInput::foo(){
    while(true)
    {
        sleep(1);
    }
    close(fd);
}
